&ANALYZE-SUSPEND _VERSION-NUMBER AB_v10r12 Character
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME C-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS C-Win
/*------------------------------------------------------------------------

  File:

  Description:

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  Author:

  Created:

------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

/* Local Variable Definitions ---                                       */

DEFINE VARIABLE ghAuditDset AS HANDLE      NO-UNDO.

{src/auditing/include/_aud-utils.i}

/* Main frame update definitions - Local tt used because dynamic browsers are not
   supported on TTY */
DEFINE TEMP-TABLE ttFilePolicy NO-UNDO
    FIELD tcPolicyGuid  AS CHARACTER
    FIELD tcFileName    AS CHARACTER LABEL "Table"              FORMAT "x(25)"
    FIELD tcCreateLevel AS CHARACTER LABEL "Create Level"       FORMAT "x(10)"
    FIELD tcUpdateLevel AS CHARACTER LABEL "Update Level"       FORMAT "x(10)"
    FIELD tcDeleteLevel AS CHARACTER LABEL "Delete Level"       FORMAT "x(10)"
    INDEX idxFile IS PRIMARY UNIQUE tcPolicyGuid tcFileName.

DEFINE TEMP-TABLE ttFieldPolicy NO-UNDO
    FIELD tcPolicyGuid  AS CHARACTER
    FIELD tcFileName    AS CHARACTER
    FIELD tcFieldName   AS CHARACTER LABEL "Field"              FORMAT "x(25)"
    FIELD tcCreateLevel AS CHARACTER LABEL "Create Level"       FORMAT "x(10)"
    FIELD tcUpdateLevel AS CHARACTER LABEL "Update Level"       FORMAT "x(10)"
    FIELD tcDeleteLevel AS CHARACTER LABEL "Delete Level"       FORMAT "x(10)"
    INDEX idxField IS PRIMARY UNIQUE tcPolicyGuid tcFileName tcFieldName.

DEFINE QUERY qFilePolicy  FOR ttFilePolicy  SCROLLING.
DEFINE QUERY qFieldPolicy FOR ttFieldPolicy SCROLLING.

DEFINE BROWSE bFilePolicy  QUERY qFilePolicy
    DISPLAY ttFilePolicy.tcFileName
            ttFilePolicy.tcCreateLevel
            ttFilePolicy.tcUpdateLevel
            ttFilePolicy.tcDeleteLevel
    WITH 4 DOWN TITLE "File Policies" WIDTH 71.

DEFINE BROWSE bFieldPolicy QUERY qFieldPolicy
    DISPLAY ttFieldPolicy.tcFieldName
            ttFieldPolicy.tcCreateLevel
            ttFieldPolicy.tcUpdateLevel
            ttFieldPolicy.tcDeleteLevel
    WITH 4 DOWN TITLE "Field Policies" WIDTH 71.

/* Policy Update Definitions */
DEFINE VARIABLE fiPolicyName        AS CHARACTER   NO-UNDO.
DEFINE VARIABLE fiPolicyDesc        AS CHARACTER   NO-UNDO.

DEFINE VARIABLE cbSecurityLevel     AS INTEGER     NO-UNDO.
DEFINE VARIABLE rsCustomDetailLevel AS INTEGER     NO-UNDO.

DEFINE VARIABLE tbPolicyActive      AS LOGICAL     NO-UNDO.

DEFINE BUTTON btnOkName     LABEL "OK" AUTO-GO.
DEFINE BUTTON btnCancelName LABEL "Cancel" AUTO-ENDKEY.

DEFINE FRAME updatePolicy SKIP(1)
                          fiPolicyName FORMAT "x(45)" COLON 26
                                       LABEL "Audit policy name"
                                       VIEW-AS FILL-IN SIZE 40 BY 1 SKIP(1)
                          fiPolicyDesc FORMAT "x(255)"  COLON 26
                                       LABEL "Audit policy description"
                                       VIEW-AS EDITOR SIZE 40 BY 3 SKIP(1)
                          cbSecurityLevel FORMAT ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
                                          COLON 26
                                          VIEW-AS COMBO-BOX SIZE 40 BY 1 INNER-LINES 4
                                          LIST-ITEM-PAIRS "No Additional Security",0,
                                                          "Message Digest",1,
                                                          "DB Passkey", 2
                                          LABEL "Data security level" SKIP(1)
                          rsCustomDetailLevel COLON 26
                                              VIEW-AS RADIO-SET HORIZONTAL
                                              RADIO-BUTTONS "Off",0,"On",1
                                              LABEL "Audit custom detail level"
                          tbPolicyActive VIEW-AS TOGGLE-BOX LABEL "Policy active" SKIP(1)
                          btnOkName       AT 25 btnCancelName
    WITH OVERLAY TITLE "Audit Policy Details" SIDE-LABELS ROW 2 CENTERED.

/* File Policy Update Definitions */
DEFINE VARIABLE cbTableName       AS CHARACTER   NO-UNDO.
DEFINE VARIABLE gcFileNames       AS CHARACTER   NO-UNDO.

DEFINE VARIABLE cbFileCreateLevel AS INTEGER     NO-UNDO.
DEFINE VARIABLE fiCreateEventId   AS INTEGER     NO-UNDO INITIAL 5100.
DEFINE VARIABLE cbFileUpdateLevel AS INTEGER     NO-UNDO.
DEFINE VARIABLE fiUpdateEventId   AS INTEGER     NO-UNDO INITIAL 5101.
DEFINE VARIABLE cbFileDeleteLevel AS INTEGER     NO-UNDO.
DEFINE VARIABLE fiDeleteEventId   AS INTEGER     NO-UNDO INITIAL 5102.

DEFINE FRAME updateFile SKIP(1)
                        cbTableName FORMAT "x(45)" COLON 19
                                    VIEW-AS COMBO-BOX SIZE 40 BY 1
                                    INNER-LINES 5
                                    LABEL "Table Name" SKIP(1)
                        cbFileCreateLevel COLON 19 FORMAT ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
                                          VIEW-AS COMBO-BOX INNER-LINES 4
                                          LIST-ITEM-PAIRS
                                            "Do not audit this table (Off)",0,
                                            "Audit table but do not store initial values (Min)",1,
                                            "Audit table and store initial values (Std)",12
                                          SIZE 52 BY 1 LABEL "Audit create level" SKIP
                        fiCreateEventId COLON 19 VIEW-AS FILL-IN SIZE 17 BY 1
                                        LABEL "Create Event ID" SKIP(1)
                        cbFileUpdateLevel COLON 19 FORMAT ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
                                          VIEW-AS COMBO-BOX INNER-LINES 5
                                          LIST-ITEM-PAIRS
                                            "Do not audit this table (Off)",0,
                                            "Audit table but do not store old and new values (Min)",1,
                                            "Audit table and store new values (Std)",12,
                                            "Audit table and store old and new values (Full)",13
                                          SIZE 52 BY 1 LABEL "Audit update level" SKIP
                        fiUpdateEventId COLON 19 VIEW-AS FILL-IN SIZE 17 BY 1
                                        LABEL "Update Event ID" SKIP(1)
                        cbFileDeleteLevel COLON 19 FORMAT ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
                                          VIEW-AS COMBO-BOX INNER-LINES 4
                                          LIST-ITEM-PAIRS
                                            "Do not audit this table (Off)",0,
                                            "Audit table but do not store deleted record (Min)",1,
                                            "Audit table and store deleted record (Std)",12
                                          SIZE 52 BY 1 LABEL "Audit delete level" SKIP
                        fiDeleteEventId COLON 19 VIEW-AS FILL-IN SIZE 17 BY 1
                                        LABEL "Delete Event ID" SKIP(1)
                        btnOkName       AT 25 btnCancelName
      WITH OVERLAY TITLE "File Policy Details" SIDE-LABELS ROW 2 CENTERED.

/* Field Policy Update Definitions */
DEFINE VARIABLE cbFieldName        AS CHARACTER   NO-UNDO.
DEFINE VARIABLE gcFieldNames        AS CHARACTER   NO-UNDO.

DEFINE VARIABLE cbFieldCreateLevel AS INTEGER     NO-UNDO.
DEFINE VARIABLE cbFieldUpdateLevel AS INTEGER     NO-UNDO.
DEFINE VARIABLE cbFieldDeleteLevel AS INTEGER     NO-UNDO.
DEFINE VARIABLE cbFieldReadLevel   AS INTEGER     NO-UNDO.
DEFINE VARIABLE fiIdentifyingField AS INTEGER     NO-UNDO.

DEFINE VARIABLE tbIdentifyingField AS LOGICAL     NO-UNDO.

DEFINE FRAME updateField SKIP(1)
                         cbFieldName FORMAT "x(45)" COLON 19
                                     VIEW-AS COMBO-BOX SIZE 40 BY 1
                                     INNER-LINES 5
                                     LABEL "Field Name" SKIP(1)
                         cbFieldCreateLevel COLON 19 FORMAT "->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
                                            VIEW-AS COMBO-BOX INNER-LINES 5
                                            LIST-ITEM-PAIRS
                                              "Do not audit this field (Off)",-1,
                                              "Use the audit level set for the table (Use Table)",0,
                                              "Do not audit this field's value (Min)",1,
                                              "Audit this field's value (Std)",12
                                            SIZE 52 BY 1 LABEL "Audit create level" SKIP
                         cbFieldUpdateLevel COLON 19 FORMAT "->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
                                            VIEW-AS COMBO-BOX INNER-LINES 5
                                            LIST-ITEM-PAIRS
                                              "Do not audit this field (Off)",-1,
                                              "Use the audit level set for the table (Use Table)",0,
                                              "Audit this field; do not record the field's value (Min)",1,
                                              "Audit this field; record the updated field value (Std)",12,
                                              "Audit this field; record old and updated field values(Full)",13
                                            SIZE 52 BY 1 LABEL "Audit update level" SKIP
                         cbFieldDeleteLevel COLON 19 FORMAT "->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
                                            VIEW-AS COMBO-BOX INNER-LINES 5
                                            LIST-ITEM-PAIRS
                                              "Do not audit this field (Off)",-1,
                                              "Use the audit level set for the table (Use Table)",0,
                                              "Do not audit this field's value (Min)",1,
                                              "Audit this field's value (Std)",12
                                            SIZE 52 BY 1 LABEL "Audit delete level" SKIP(1)
                         cbFieldReadLevel COLON 19 FORMAT ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
                                          VIEW-AS COMBO-BOX INNER-LINES 4
                                          LIST-ITEM-PAIRS "Use Table",0,
                                                          "Minimum Audit Data",1,
                                                          "Standard Audit Data",2
                                          SIZE 36 BY 1 LABEL "Audit read level" SKIP(1)
                         tbIdentifyingField COLON 19 VIEW-AS TOGGLE-BOX
                                            LABEL "Identifying Field" SKIP
                         fiIdentifyingField COLON 40 VIEW-AS FILL-IN SIZE 4 BY 1
                                            LABEL "Ordinal Position" SKIP(1)
                         btnOkName       AT 25 btnCancelName
      WITH OVERLAY TITLE "Field Policy Details" SIDE-LABELS ROW 2 CENTERED.

SESSION:DEBUG-ALERT = TRUE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Window
&Scoped-define DB-AWARE no

&Scoped-define LAYOUT-VARIABLE C-Win-layout

/* Name of designated FRAME-NAME and/or first browse and/or first query */
&Scoped-define FRAME-NAME DEFAULT-FRAME

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS cbDatabase cbPolicies btnAddPolicy ~
btnUpdatePolicy btnNewFilePolicy btnNewFieldPolicy btnSave btnDone
&Scoped-Define DISPLAYED-OBJECTS cbDatabase cbPolicies

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME

 

/* Define a variable to store the name of the active layout.            */
DEFINE VAR C-Win-layout AS CHAR INITIAL "Master Layout":U NO-UNDO.

/* ***********************  Control Definitions  ********************** */

/* Define the widget handle for the window                              */
DEFINE VAR C-Win AS WIDGET-HANDLE NO-UNDO.

/* Definitions of the field level widgets                               */
DEFINE BUTTON btnAddPolicy
     LABEL "Add"
     &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN SIZE 6 BY 1
     &ELSE SIZE 6 BY 1 &ENDIF.

DEFINE BUTTON btnDone
     LABEL "Done"
     &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN SIZE 10 BY 1
     &ELSE SIZE 10 BY 1 &ENDIF.

DEFINE BUTTON btnNewFieldPolicy
     LABEL "New"
     &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN SIZE 8 BY 1
     &ELSE SIZE 8 BY 1 &ENDIF.

DEFINE BUTTON btnNewFilePolicy
     LABEL "New"
     &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN SIZE 8 BY 1
     &ELSE SIZE 8 BY 1 &ENDIF.

DEFINE BUTTON btnSave
     LABEL "Save Changes"
     &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN SIZE 15 BY 1
     &ELSE SIZE 15 BY 1 &ENDIF.

DEFINE BUTTON btnUpdatePolicy
     LABEL "Update"
     &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN SIZE 8 BY 1
     &ELSE SIZE 8 BY 1 &ENDIF.

DEFINE VARIABLE cbDatabase AS CHARACTER FORMAT "X(256)":U
     LABEL "Databases"
     VIEW-AS COMBO-BOX INNER-LINES 5
     DROP-DOWN-LIST
     &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN SIZE 38 BY 1
     &ELSE SIZE 38 BY 1 &ENDIF NO-UNDO.

DEFINE VARIABLE cbPolicies AS CHARACTER FORMAT "X(256)":U
     LABEL "Policies"
     VIEW-AS COMBO-BOX INNER-LINES 5
     DROP-DOWN-LIST
     &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN SIZE 38 BY 1
     &ELSE SIZE 38 BY 1 &ENDIF NO-UNDO.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME DEFAULT-FRAME
     cbDatabase
          &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN AT ROW 1 COL 11 COLON-ALIGNED
          &ELSE AT ROW 1 COL 11 COLON-ALIGNED &ENDIF WIDGET-ID 8
     cbPolicies
          &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN AT ROW 3 COL 11 COLON-ALIGNED
          &ELSE AT ROW 3 COL 11 COLON-ALIGNED &ENDIF WIDGET-ID 6
     btnAddPolicy
          &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN AT ROW 3 COL 52
          &ELSE AT ROW 3 COL 52 &ENDIF WIDGET-ID 10
     btnUpdatePolicy
          &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN AT ROW 3 COL 59
          &ELSE AT ROW 3 COL 59 &ENDIF
     btnNewFilePolicy
          &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN AT ROW 8 COL 72
          &ELSE AT ROW 8 COL 72 &ENDIF
     btnNewFieldPolicy
          &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN AT ROW 16 COL 72
          &ELSE AT ROW 16 COL 72 &ENDIF
     btnSave
          &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN AT ROW 21 COL 46
          &ELSE AT ROW 21 COL 46 &ENDIF WIDGET-ID 2
     btnDone
          &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN AT ROW 21 COL 62
          &ELSE AT ROW 21 COL 62 &ENDIF
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY
         SIDE-LABELS NO-UNDERLINE THREE-D
         AT COL 1 ROW 1
         SIZE 80 BY 21 WIDGET-ID 100.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Window
   Allow: Basic,Browse,DB-Fields,Window,Query
   Other Settings: COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
IF SESSION:DISPLAY-TYPE = "GUI":U THEN
  CREATE WINDOW C-Win ASSIGN
         HIDDEN             = YES
         TITLE              = "<insert window title>"
         HEIGHT             = 21.07
         WIDTH              = 79.86
         MAX-HEIGHT         = 21.07
         MAX-WIDTH          = 79.86
         VIRTUAL-HEIGHT     = 21.07
         VIRTUAL-WIDTH      = 79.86
         RESIZE             = yes
         SCROLL-BARS        = no
         STATUS-AREA        = no
         BGCOLOR            = ?
         FGCOLOR            = ?
         KEEP-FRAME-Z-ORDER = yes
         THREE-D            = yes
         MESSAGE-AREA       = no
         SENSITIVE          = yes.
ELSE {&WINDOW-NAME} = CURRENT-WINDOW.
/* END WINDOW DEFINITION                                                */
&ANALYZE-RESUME

 

/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW C-Win
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME DEFAULT-FRAME
   FRAME-NAME                                                           */

/* _MULTI-LAYOUT-RUN-TIME-ADJUSTMENTS */

/* LAYOUT-NAME: "Standard Character"
   LAYOUT-TYPE: CHARACTER
   EXPRESSION:  SESSION:DISPLAY-TYPE = 'TTY':U
   COMMENT:     This layout is the standard layout specification for
                 a customized Character based terminal.  It is usually
                 selected to modify a window that has a GUI based
                 master layout.
                                                                        */
IF SESSION:DISPLAY-TYPE = 'TTY':U  THEN
  RUN C-Win-layouts (INPUT 'Standard Character':U) NO-ERROR.

/* LAYOUT-NAME: "winlayout"
   LAYOUT-TYPE: GUI
   EXPRESSION:  FALSE
   COMMENT:    
                                                                        */
ELSE IF FALSE THEN
  RUN C-Win-layouts (INPUT 'winlayout':U) NO-ERROR.

/* END-OF-LAYOUT-DEFINITIONS */

IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)
THEN C-Win:HIDDEN = no.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME

 

 

/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME C-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON END-ERROR OF C-Win /* <insert window title> */
OR ENDKEY OF {&WINDOW-NAME} ANYWHERE DO:
  /* This case occurs when the user presses the "Esc" key.
     In a persistently run window, just ignore this.  If we did not, the
     application would exit. */
  IF THIS-PROCEDURE:PERSISTENT THEN RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON WINDOW-CLOSE OF C-Win /* <insert window title> */
DO:
  /* This event will close the window and terminate the procedure.  */
  APPLY "CLOSE":U TO THIS-PROCEDURE.
  RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME btnAddPolicy
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL btnAddPolicy C-Win
ON CHOOSE OF btnAddPolicy IN FRAME DEFAULT-FRAME /* Add */
DO:
  DEFINE VARIABLE lCancelled   AS LOGICAL     NO-UNDO.

  ASSIGN fiPolicyName        = ""
         fiPolicyDesc        = ""
         cbSecurityLevel     = 0
         rsCustomDetailLevel = 0
         tbPolicyActive      = FALSE.

  lCancelled = FALSE.
  ON CHOOSE OF btnCancelName IN FRAME updatePolicy
    lCancelled = TRUE.

  UPDATE fiPolicyName fiPolicyDesc cbSecurityLevel rsCustomDetailLevel
         tbPolicyActive btnOkName btnCancelName
      WITH FRAME updatePolicy.
  HIDE FRAME updatePolicy.
  RUN localEnable.

  IF lCancelled THEN
    RETURN NO-APPLY.

  RUN addNewPolicy ( INPUT fiPolicyName,
                     INPUT fiPolicyDesc,
                     INPUT cbSecurityLevel,
                     INPUT rsCustomDetailLevel,
                     INPUT tbPolicyActive,
                     INPUT cbPolicies:HANDLE IN FRAME {&FRAME-NAME} ).

END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME btnDone
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL btnDone C-Win
ON CHOOSE OF btnDone IN FRAME DEFAULT-FRAME /* Done */
DO:
  APPLY "CLOSE" TO THIS-PROCEDURE.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME btnNewFieldPolicy
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL btnNewFieldPolicy C-Win
ON CHOOSE OF btnNewFieldPolicy IN FRAME DEFAULT-FRAME /* New */
DO:
  DEFINE VARIABLE hFieldBuffer AS HANDLE      NO-UNDO.

  DEFINE VARIABLE lCancelled   AS LOGICAL     NO-UNDO.

  DEFINE VARIABLE rowNewPolicy AS ROWID       NO-UNDO.

  IF NOT AVAILABLE ttFilePolicy THEN
    RETURN NO-APPLY.

  hFieldBuffer = ghAuditDset::ttAuditFieldPolicy.
  rowNewPolicy = ?.

  ASSIGN cbFieldName:LIST-ITEMS IN FRAME updateField = gcFieldNames
         cbFieldName                                = ""
         cbFieldCreateLevel                         = 0
         cbFieldUpdateLevel                         = 0
         cbFieldDeleteLevel                         = 0
         cbFieldReadLevel                           = 0
         fiIdentifyingField                         = 0
         tbIdentifyingField                         = FALSE.
 
  ON CHOOSE OF btnCancelName IN FRAME updateField
    lCancelled = TRUE.

  ON VALUE-CHANGED OF tbIdentifyingField IN FRAME updateField DO:
    fiIdentifyingField:SENSITIVE IN FRAME updateField = (SELF:CHECKED).
    fiIdentifyingField:SCREEN-VALUE = '0'.
  END.

  UPDATE cbFieldName cbFieldCreateLevel cbFieldUpdateLevel cbFieldDeleteLevel
         cbFieldReadLevel tbIdentifyingField fiIdentifyingField WHEN tbIdentifyingField
         btnOkName btnCancelName
      WITH FRAME updateField.
  ASSIGN fiIdentifyingField.
  HIDE FRAME updateField.
  RUN localEnable.

  IF lCancelled THEN
    RETURN NO-APPLY.

  RUN addFieldPolicy ( INPUT ttFilePolicy.tcPolicyGuid,
                       INPUT ttFilePolicy.tcFileName,
                       INPUT cbFieldName,
                       INPUT cbFieldCreateLevel,
                       INPUT cbFieldUpdateLevel,
                       INPUT cbFieldDeleteLevel,
                       INPUT cbFieldReadLevel,
                       INPUT fiIdentifyingField,
                       OUTPUT rowNewPolicy ).

  OPEN QUERY qFieldPolicy FOR EACH ttFieldPolicy NO-LOCK
                              WHERE ttFieldPolicy.tcPolicyGuid EQ ttFilePolicy.tcPolicyGuid AND
                                    ttFieldPolicy.tcFileName   EQ ttFilePolicy.tcFileName.
  IF rowNewPolicy NE ? THEN
    REPOSITION qFieldPolicy TO ROWID rowNewPolicy.

  APPLY "VALUE-CHANGED" TO BROWSE bFieldPolicy.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME btnNewFilePolicy
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL btnNewFilePolicy C-Win
ON CHOOSE OF btnNewFilePolicy IN FRAME DEFAULT-FRAME /* New */
DO:
  DEFINE VARIABLE hFileBuffer AS HANDLE      NO-UNDO.

  DEFINE VARIABLE lCancelled  AS LOGICAL     NO-UNDO.

  DEFINE VARIABLE rowNewPolicy AS ROWID       NO-UNDO.

  hFileBuffer = ghAuditDset::ttAuditFilePolicy.
 
  ASSIGN cbTableName:LIST-ITEMS IN FRAME updateFile = gcFileNames
         cbTableName                                = ""
         cbFileCreateLevel                          = 0
         fiCreateEventId                            = 5100
         cbFileUpdateLevel                          = 0
         fiUpdateEventId                            = 5101
         cbFileDeleteLevel                          = 0
         fiDeleteEventId                            = 5102.

  ON CHOOSE OF btnCancelName IN FRAME updateFile
    lCancelled = TRUE.

  UPDATE cbTableName cbFileCreateLevel fiCreateEventId cbFileUpdateLevel
         fiUpdateEventId cbFileDeleteLevel fiDeleteEventId
         btnOkName btnCancelName
      WITH FRAME updateFile.
  HIDE FRAME updateFile.
  RUN localEnable.

  IF lCancelled THEN
    RETURN NO-APPLY.

  RUN addFilePolicy ( INPUT cbPolicies:SCREEN-VALUE IN FRAME {&FRAME-NAME},
                      INPUT cbTableName,
                      INPUT cbFileCreateLevel,
                      INPUT fiCreateEventId,
                      INPUT cbFileUpdateLevel,
                      INPUT fiUpdateEventId,
                      INPUT cbFileDeleteLevel,
                      INPUT fiDeleteEventId,
                      OUTPUT rowNewPolicy ).

  OPEN QUERY qFilePolicy FOR EACH ttFilePolicy NO-LOCK
                           WHERE ttFilePolicy.tcPolicyGuid EQ
                                      cbPolicies:SCREEN-VALUE IN FRAME {&FRAME-NAME}.
  IF rowNewPolicy NE ? THEN
    REPOSITION qFilePolicy TO ROWID rowNewPolicy.

  APPLY "VALUE-CHANGED" TO BROWSE bFilePolicy.

END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME btnSave
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL btnSave C-Win
ON CHOOSE OF btnSave IN FRAME DEFAULT-FRAME /* Save Changes */
DO:
  RUN writeChanges.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME btnUpdatePolicy
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL btnUpdatePolicy C-Win
ON CHOOSE OF btnUpdatePolicy IN FRAME DEFAULT-FRAME /* Update */
DO:
  DEFINE VARIABLE hPolicyBuffer AS HANDLE      NO-UNDO.

  DEFINE VARIABLE lCancelled    AS LOGICAL     NO-UNDO.

  hPolicyBuffer = ghAuditDset::ttAuditPolicy.
  hPolicyBuffer:FIND-FIRST("WHERE " + hPolicyBuffer:NAME +
                           "._audit-policy-guid EQ ~'" +
                           cbPolicies:SCREEN-VALUE + "~'",
                           NO-LOCK) NO-ERROR.
  IF NOT hPolicyBuffer:AVAILABLE THEN
    RETURN NO-APPLY.

  ASSIGN fiPolicyName        = hPolicyBuffer::_audit-policy-name
         fiPolicyDesc        = hPolicyBuffer::_audit-policy-description
         cbSecurityLevel     = hPolicyBuffer::_audit-data-security-level
         rsCustomDetailLevel = hPolicyBuffer::_audit-custom-detail-level
         tbPolicyActive      = hPolicyBuffer::_audit-policy-active.

  ON CHOOSE OF btnCancelName IN FRAME updatePolicy
    lCancelled = TRUE.

  lCancelled = FALSE.
  UPDATE fiPolicyName fiPolicyDesc cbSecurityLevel rsCustomDetailLevel
         tbPolicyActive btnOkName btnCancelName
      WITH FRAME updatePolicy.
  HIDE FRAME updatePolicy.
  RUN localEnable.

  IF lCancelled THEN
    RETURN NO-APPLY.

  RUN updatePolicy ( INPUT cbPolicies:SCREEN-VALUE,
                     INPUT fiPolicyName,
                     INPUT fiPolicyDesc,
                     INPUT cbSecurityLevel,
                     INPUT rsCustomDetailLevel,
                     INPUT tbPolicyActive,
                     INPUT cbPolicies:HANDLE IN FRAME {&FRAME-NAME} ).
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME cbDatabase
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL cbDatabase C-Win
ON VALUE-CHANGED OF cbDatabase IN FRAME DEFAULT-FRAME /* Databases */
DO:
  RUN loadPolicyList ( INPUT SELF:SCREEN-VALUE,
                       INPUT cbPolicies:HANDLE IN FRAME {&FRAME-NAME} ).
  RUN setTrackingChanges ( INPUT TRUE ).
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME cbPolicies
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL cbPolicies C-Win
ON VALUE-CHANGED OF cbPolicies IN FRAME DEFAULT-FRAME /* Policies */
DO:
  RUN loadPolicyDetails ( INPUT SELF:SCREEN-VALUE ).
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK C-Win


/* ***************************  Main Block  *************************** */

/* Set CURRENT-WINDOW: this will parent dialog-boxes and frames.        */
ASSIGN CURRENT-WINDOW                = {&WINDOW-NAME}
       THIS-PROCEDURE:CURRENT-WINDOW = {&WINDOW-NAME}.

/* The CLOSE event can be used from inside or outside the procedure to  */
/* terminate it.                                                        */
ON CLOSE OF THIS-PROCEDURE
   RUN disable_UI.

/* Best default for GUI applications is...                              */
PAUSE 0 BEFORE-HIDE.

DEFINE FRAME {&FRAME-NAME} bFilePolicy  AT COL 1 ROW 5
                           bFieldPolicy AT COL 1 ROW 13.

ON VALUE-CHANGED OF BROWSE bFilePolicy DO:
  DEFINE VARIABLE h_FieldBuffer AS HANDLE      NO-UNDO.
  DEFINE VARIABLE h_FileBuffer  AS HANDLE      NO-UNDO.
  DEFINE VARIABLE h_FieldQuery  AS HANDLE      NO-UNDO.

  IF NOT AVAILABLE ttFilePolicy THEN
    RETURN NO-APPLY.

  CREATE WIDGET-POOL.
  CREATE BUFFER h_FieldBuffer FOR TABLE
        cbDatabase:SCREEN-VALUE IN FRAME {&FRAME-NAME} + "._field".
  CREATE BUFFER h_FileBuffer  FOR TABLE
        cbDatabase:SCREEN-VALUE IN FRAME {&FRAME-NAME} + "._file".
  h_FileBuffer:FIND-FIRST("WHERE _File._Tbl-type EQ ~'T~' AND " +
                          "_File._File-name EQ ~'" + ttFilePolicy.tcFileName + "~'",
                          NO-LOCK) NO-ERROR.


  CREATE QUERY h_FieldQuery.
  h_FieldQuery:SET-BUFFERS(h_FieldBuffer).
  h_FieldQuery:QUERY-PREPARE("FOR EACH _Field WHERE _Field._file-recid EQ " +
                             STRING(h_FileBuffer:RECID) + " NO-LOCK").
  h_FieldQuery:QUERY-OPEN().
  h_FieldQuery:GET-FIRST().

  gcFieldNames = " ,".
  DO WHILE NOT h_FieldQuery:QUERY-OFF-END:
    gcFieldNames = gcFieldNames + (IF (gcFieldNames GT "") EQ TRUE THEN "," ELSE "") +
                  h_FieldBuffer::_field-name.
    h_FieldQuery:GET-NEXT().
  END.

  OPEN QUERY qFieldPolicy
       FOR EACH ttFieldPolicy
           WHERE ttFieldPolicy.tcPolicyGuid EQ ttFilePolicy.tcPolicyGuid AND
                 ttFieldPolicy.tcFileName   EQ ttFilePolicy.tcFileName
           NO-LOCK.
END.

ON DEFAULT-ACTION OF BROWSE bFilePolicy DO:
  DEFINE VARIABLE lCancelled AS LOGICAL     NO-UNDO.

  DEFINE VARIABLE rowRepos   AS ROWID       NO-UNDO.

  DEFINE VARIABLE hFileBuffer AS HANDLE      NO-UNDO.

  IF NOT AVAILABLE ttFilePolicy THEN
    RETURN NO-APPLY.

  ASSIGN rowRepos    = ?
         rowRepos    = ROWID(ttFilePolicy)
         hFileBuffer = ghAuditDset::ttAuditFilePolicy.
 
  hFileBuffer:FIND-FIRST("WHERE " + hFileBuffer:NAME + "._audit-policy-guid EQ ~'" +
                         ttFilePolicy.tcPolicyGuid + "~' AND " + hFileBuffer:NAME +
                         "._file-name EQ ~'" + ttFilePolicy.tcFileName + "~'",
                           NO-LOCK) NO-ERROR.
  IF NOT hFileBuffer:AVAILABLE THEN
    RETURN NO-APPLY.

  ASSIGN cbTableName:LIST-ITEMS IN FRAME updateFile = gcFileNames
         cbTableName                                = hFileBuffer::_file-name
         cbFileCreateLevel                          = hFileBuffer::_audit-create-level
         fiCreateEventId                            = hFileBuffer::_create-event-id
         cbFileUpdateLevel                          = hFileBuffer::_audit-update-level
         fiUpdateEventId                            = hFileBuffer::_update-event-id
         cbFileDeleteLevel                          = hFileBuffer::_audit-delete-level
         fiDeleteEventId                            = hFileBuffer::_delete-event-id.

  lCancelled = FALSE.
  ON CHOOSE OF btnCancelName IN FRAME updateFile
    lCancelled = TRUE.

  UPDATE cbTableName cbFileCreateLevel fiCreateEventId cbFileUpdateLevel
         fiUpdateEventId cbFileDeleteLevel fiDeleteEventId
         btnOkName btnCancelName
      WITH FRAME updateFile.
  HIDE FRAME updateFile.
  RUN localEnable.

  IF lCancelled THEN
    RETURN NO-APPLY.

  RUN updateFilePolicy ( INPUT ttFilePolicy.tcPolicyGuid,
                         INPUT ttFilePolicy.tcFileName,
                         INPUT cbTableName,
                         INPUT cbFileCreateLevel,
                         INPUT fiCreateEventId,
                         INPUT cbFileUpdateLevel,
                         INPUT fiUpdateEventId,
                         INPUT cbFileDeleteLevel,
                         INPUT fiDeleteEventId ).

  OPEN QUERY qFilePolicy FOR EACH ttFilePolicy NO-LOCK
                             WHERE ttFilePolicy.tcPolicyGuid EQ
                                        cbPolicies:SCREEN-VALUE IN FRAME {&FRAME-NAME}.
  IF rowRepos NE ? THEN
    REPOSITION qFilePolicy TO ROWID rowRepos.

  APPLY "VALUE-CHANGED" TO BROWSE bFilePolicy.
END.

ON DEL OF BROWSE bFilePolicy DO:
  DEFINE VARIABLE cGuid       AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE cTableName  AS CHARACTER   NO-UNDO.

  DEFINE VARIABLE lDelete     AS LOGICAL     NO-UNDO.

  DEFINE VARIABLE hFilePolicy AS HANDLE      NO-UNDO.

  DEFINE BUFFER policyBuffer FOR ttFilePolicy.
 
  hFilePolicy = ghAuditDset::ttAuditFilePolicy.

  IF NOT AVAILABLE ttFilePolicy THEN
    RETURN NO-APPLY.

  MESSAGE "Are you sure you want to delete this policy?  " SKIP(1)
          "All field policies associated with this policy will also be removed."
      VIEW-AS ALERT-BOX QUESTION BUTTONS YES-NO UPDATE lDelete.

  IF NOT lDelete THEN
    RETURN NO-APPLY.

  ASSIGN cGuid      = ttfilePolicy.tcPolicyGuid
         cTableName = ttFilePolicy.tcFileName.

  DO TRANSACTION:
    FIND policyBuffer WHERE ROWID(policyBuffer) EQ ROWID(ttFilePolicy)
         EXCLUSIVE-LOCK NO-ERROR.
    IF NOT AVAILABLE policyBuffer THEN
      RETURN NO-APPLY.

    hFilePolicy:FIND-FIRST("WHERE " + hFilePolicy:NAME +
                           "._audit-policy-guid EQ ~'" +
                           cGuid + "~' AND " + hFilePolicy:NAME +
                           "._file-name EQ ~'" + cTableName + "~'",
                           EXCLUSIVE-LOCK) NO-ERROR.
    IF NOT hFilePolicy:AVAILABLE THEN
      RETURN NO-APPLY.

    RUN deleteFields ( INPUT policyBuffer.tcPolicyGuid,
                       INPUT policyBuffer.tcFileName ).
 
    DELETE policyBuffer.
    hFilePolicy:BUFFER-DELETE().
  END.
  OPEN QUERY qFilePolicy FOR EACH ttFilePolicy NO-LOCK
                             WHERE ttFilePolicy.tcPolicyGuid EQ
                                        cbPolicies:SCREEN-VALUE IN FRAME {&FRAME-NAME}.
  APPLY "VALUE-CHANGED" TO BROWSE bFilePolicy.
END.

ON DEFAULT-ACTION OF BROWSE bFieldPolicy DO:
  DEFINE VARIABLE cGuid      AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE cTableName AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE cFieldName AS CHARACTER   NO-UNDO.

  DEFINE VARIABLE lCancelled AS LOGICAL     NO-UNDO.

  DEFINE VARIABLE rowRepos   AS ROWID       NO-UNDO.

  DEFINE VARIABLE hFieldBuffer AS HANDLE      NO-UNDO.

  IF NOT AVAILABLE ttFieldPolicy THEN
    RETURN NO-APPLY.

  ASSIGN rowRepos     = ?
         rowRepos     = ROWID(ttFieldPolicy)
         hFieldBuffer = ghAuditDset::ttAuditFieldPolicy
         cGuid        = ttFieldPolicy.tcPolicyGuid
         cTableName   = ttFieldPolicy.tcFileName
         cFieldName   = ttFieldPolicy.tcFieldName.
 
  hFieldBuffer:FIND-FIRST("WHERE " + hFieldBuffer:NAME + "._audit-policy-guid EQ ~'" +
                          cGuid + "~' AND " + hFieldBuffer:NAME + "._file-name EQ ~'" +
                          cTableName + "~' AND " + hFieldBuffer:NAME + "._field-name EQ ~'" +
                          cFieldName + "~'",NO-LOCK) NO-ERROR.
  IF NOT hFieldBuffer:AVAILABLE THEN
    RETURN NO-APPLY.

  ASSIGN cbFieldName:LIST-ITEMS IN FRAME updateField = gcFieldNames
         cbFieldName                                 = hFieldBuffer::_field-name
         cbFieldCreateLevel                          = hFieldBuffer::_audit-create-level
         cbFieldUpdateLevel                          = hFieldBuffer::_audit-update-level
         cbFieldDeleteLevel                          = hFieldBuffer::_audit-delete-level
         cbFieldReadLevel                            = hFieldBuffer::_audit-read-level
         tbIdentifyingField                          = (hFieldBuffer::_audit-identifying-field GT 0 AND
                                                        hFieldBuffer::_audit-identifying-field NE ?)
         fiIdentifyingField                          = hFieldBuffer::_audit-identifying-field.

  lCancelled = FALSE.
  ON CHOOSE OF btnCancelName IN FRAME updateField
    lCancelled = TRUE.

  UPDATE cbFieldName cbFieldCreateLevel cbFieldUpdateLevel cbFieldDeleteLevel
         cbFieldReadLevel tbIdentifyingField fiIdentifyingField WHEN tbIdentifyingField
         btnOkName btnCancelName
      WITH FRAME updateField.
  HIDE FRAME updateField.
  RUN localEnable.

  IF lCancelled THEN
    RETURN NO-APPLY.

  RUN updateFieldPolicy ( INPUT cGuid,
                          INPUT cTableName,
                          INPUT cFieldName,
                          INPUT cbFieldName,
                          INPUT cbFieldCreateLevel,
                          INPUT cbFieldUpdateLevel,
                          INPUT cbFieldDeleteLevel,
                          INPUT cbFieldReadLevel,
                          INPUT fiIdentifyingField ).

  OPEN QUERY qFieldPolicy FOR EACH ttFieldPolicy NO-LOCK
                             WHERE ttFieldPolicy.tcPolicyGuid EQ cGuid AND
                                   ttFieldPolicy.tcFileName   EQ cTableName.
  IF rowRepos NE ? THEN
    REPOSITION qFieldPolicy TO ROWID rowRepos.

  APPLY "VALUE-CHANGED" TO BROWSE bFieldPolicy.
END.

ON DEL OF BROWSE bFieldPolicy DO:
  DEFINE VARIABLE cGuid        AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE cTableName   AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE cFieldName   AS CHARACTER   NO-UNDO.

  DEFINE VARIABLE hFieldPolicy AS HANDLE      NO-UNDO.

  DEFINE VARIABLE lDelete      AS LOGICAL     NO-UNDO.

  DEFINE BUFFER fieldPolicyBuffer FOR ttFieldPolicy.

  hFieldPolicy = ghAuditDset::ttAuditFieldPolicy.

  IF NOT AVAILABLE ttFieldPolicy THEN
    RETURN NO-APPLY.

  ASSIGN cGuid      = ttFieldPolicy.tcPolicyGuid
         cTableName = ttFieldPolicy.tcFileName
         cFieldName = ttFieldPolicy.tcFieldName.

  MESSAGE "Are you sure you want to delete this policy?"
      VIEW-AS ALERT-BOX QUESTION BUTTONS YES-NO UPDATE lDelete.

  IF NOT lDelete THEN
    RETURN NO-APPLY.

  DO TRANSACTION:
    FIND fieldPolicyBuffer WHERE ROWID(fieldPolicyBuffer) EQ ROWID(ttFieldPolicy)
         EXCLUSIVE-LOCK NO-ERROR.
    IF NOT AVAILABLE fieldPolicyBuffer THEN
      RETURN NO-APPLY.

    hFieldPolicy:FIND-FIRST("WHERE " + hFieldPolicy:NAME +
                            "._audit-policy-guid EQ ~'" + cGuid +
                            "~' AND " + hFieldPolicy:NAME +
                            "._file-name EQ ~'" + cTableName +
                            "~' AND " + hFieldPolicy:NAME +
                            "._field-name EQ ~'" + cFieldName + "~'",
                            EXCLUSIVE-LOCK) NO-ERROR.
    IF NOT hFieldPolicy:AVAILABLE THEN
      RETURN NO-APPLY.
 
    DELETE fieldPolicyBuffer.
    hFieldPolicy:BUFFER-DELETE().
    OPEN QUERY qFieldPolicy FOR EACH ttFieldPolicy NO-LOCK
                                WHERE ttFieldPolicy.tcPolicyGuid EQ cGuid AND
                                      ttFieldPolicy.tcFileName   EQ cTableName.
    END.
  APPLY "VALUE-CHANGED" TO BROWSE bFieldPolicy.
END.

/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:
  RUN enable_UI.
  RUN loadDBList ( INPUT cbDatabase:HANDLE IN FRAME {&FRAME-NAME} ).
  RUN localEnable.
  IF NOT THIS-PROCEDURE:PERSISTENT THEN
    WAIT-FOR CLOSE OF THIS-PROCEDURE.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE addFieldPolicy C-Win
PROCEDURE addFieldPolicy :
/*------------------------------------------------------------------------------
  Purpose:    
  Parameters:  <none>
  Notes:      
------------------------------------------------------------------------------*/
  DEFINE INPUT  PARAMETER pcGuid             AS CHARACTER   NO-UNDO.
  DEFINE INPUT  PARAMETER pcTableName        AS CHARACTER   NO-UNDO.
  DEFINE INPUT  PARAMETER pcFieldName        AS CHARACTER   NO-UNDO.
  DEFINE INPUT  PARAMETER piCreateLevel      AS INTEGER     NO-UNDO.
  DEFINE INPUT  PARAMETER piUpdateLevel      AS INTEGER     NO-UNDO.
  DEFINE INPUT  PARAMETER piDeleteLevel      AS INTEGER     NO-UNDO.
  DEFINE INPUT  PARAMETER piReadLevel        AS INTEGER     NO-UNDO.
  DEFINE INPUT  PARAMETER piIdentifyingField AS INTEGER     NO-UNDO.
  DEFINE OUTPUT PARAMETER prowNewPolicy      AS ROWID       NO-UNDO.

  DEFINE VARIABLE hFieldBuffer   AS HANDLE      NO-UNDO.

  DEFINE BUFFER bFieldPolicy FOR ttFieldPolicy.

  FIND FIRST bFieldPolicy WHERE bFieldPolicy.tcPolicyGuid EQ pcGuid      AND
                                bFieldPolicy.tcFileName   EQ pcTableName AND
                                bFieldPolicy.tcFieldName  EQ pcFieldName NO-LOCK NO-ERROR.
  IF AVAILABLE bFieldPolicy THEN
    RETURN.

  DO TRANSACTION:
    hFieldBuffer = ghAuditDset::ttAuditFieldPolicy.
    hFieldBuffer:BUFFER-CREATE().
 
    ASSIGN hFieldBuffer::_audit-policy-guid       = pcGuid
           hFieldBuffer::_owner                   = "PUB"
           hFieldBuffer::_file-name               = pcTableName
           hFieldBuffer::_field-name              = pcFieldName
           hFieldBuffer::_audit-create-level      = piCreateLevel
           hFieldBuffer::_audit-update-level      = piUpdateLevel
           hFieldBuffer::_audit-delete-level      = piDeleteLevel
           hFieldBuffer::_audit-read-level        = piReadLevel
           hFieldBuffer::_Audit-identifying-field = piIdentifyingField.

    CREATE bFieldPolicy.
    ASSIGN bFieldPolicy.tcPolicyGuid  = pcGuid
           bFieldPolicy.tcFileName    = pcTableName
           bFieldPolicy.tcFieldName   = pcFieldName
           bFieldPolicy.tcCreateLevel = ENTRY(LOOKUP(STRING(piCreateLevel),"0,1,12"),
                                             "Off,Minimum,Standard")
           bFieldPolicy.tcUpdateLevel = ENTRY(LOOKUP(STRING(piUpdateLevel),"0,1,12,13"),
                                             "Off,Minimum,Standard,Full")
           bFieldPolicy.tcDeleteLevel = ENTRY(LOOKUP(STRING(piDeleteLevel),"0,1,12"),
                                             "Off,Minimum,Standard")
           prowNewPolicy             = ROWID(bFieldPolicy).
  END.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE addFilePolicy C-Win
PROCEDURE addFilePolicy :
/*------------------------------------------------------------------------------
  Purpose:    
  Parameters:  <none>
  Notes:      
------------------------------------------------------------------------------*/
  DEFINE INPUT  PARAMETER pcGuid          AS CHARACTER   NO-UNDO.
  DEFINE INPUT  PARAMETER pcTableName     AS CHARACTER   NO-UNDO.
  DEFINE INPUT  PARAMETER piCreateLevel   AS INTEGER     NO-UNDO.
  DEFINE INPUT  PARAMETER piCreateEventId AS INTEGER     NO-UNDO.
  DEFINE INPUT  PARAMETER piUpdateLevel   AS INTEGER     NO-UNDO.
  DEFINE INPUT  PARAMETER piUpdateEventId AS INTEGER     NO-UNDO.
  DEFINE INPUT  PARAMETER piDeleteLevel   AS INTEGER     NO-UNDO.
  DEFINE INPUT  PARAMETER piDeleteEventId AS INTEGER     NO-UNDO.
  DEFINE OUTPUT PARAMETER prowNewPolicy   AS ROWID       NO-UNDO.

  DEFINE VARIABLE hFileBuffer   AS HANDLE      NO-UNDO.

  DEFINE BUFFER bFilePolicy FOR ttFilePolicy.

  FIND FIRST bFilePolicy WHERE bFilePolicy.tcPolicyGuid EQ pcGuid     AND
                               bFilePolicy.tcFileName   EQ pcTableName NO-LOCK NO-ERROR.
  IF AVAILABLE bFilePolicy THEN
    RETURN.

  DO TRANSACTION:
    hFileBuffer = ghAuditDset::ttAuditFilePolicy.
    hFileBuffer:BUFFER-CREATE().
 
    ASSIGN hFileBuffer::_audit-policy-guid  = pcGuid
           hFileBuffer::_owner              = "PUB"
           hFileBuffer::_file-name          = pcTableName
           hFileBuffer::_audit-create-level = piCreateLevel
           hFileBuffer::_create-event-id    = piCreateEventId
           hFileBuffer::_audit-update-level = piUpdateLevel
           hFileBuffer::_update-event-id    = piUpdateEventId
           hFileBuffer::_audit-delete-level = piDeleteLevel
           hFileBuffer::_delete-event-id    = piDeleteEventId.

    CREATE bFilePolicy.
    ASSIGN bFilePolicy.tcPolicyGuid  = pcGuid
           bFilePolicy.tcFileName    = pcTableName
           bFilePolicy.tcCreateLevel = ENTRY(LOOKUP(STRING(piCreateLevel),"0,1,12"),
                                             "Off,Minimum,Standard")
           bFilePolicy.tcUpdateLevel = ENTRY(LOOKUP(STRING(piUpdateLevel),"0,1,12,13"),
                                             "Off,Minimum,Standard,Full")
           bFilePolicy.tcDeleteLevel = ENTRY(LOOKUP(STRING(piDeleteLevel),"0,1,12"),
                                             "Off,Minimum,Standard")
           prowNewPolicy             = ROWID(bFilePolicy).
  END.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE addNewPolicy C-Win
PROCEDURE addNewPolicy :
/*------------------------------------------------------------------------------
  Purpose:    
  Parameters:  <none>
  Notes:      
------------------------------------------------------------------------------*/
  DEFINE INPUT  PARAMETER pcPolicyName   AS CHARACTER   NO-UNDO.
  DEFINE INPUT  PARAMETER pcPolicyDesc   AS CHARACTER   NO-UNDO.
  DEFINE INPUT  PARAMETER piSecurity     AS INTEGER     NO-UNDO.
  DEFINE INPUT  PARAMETER piCustomDetail AS INTEGER     NO-UNDO.
  DEFINE INPUT  PARAMETER plActive       AS LOGICAL     NO-UNDO.
  DEFINE INPUT  PARAMETER phList         AS HANDLE      NO-UNDO.

  DEFINE VARIABLE cBase64UUID   AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE cGuid         AS CHARACTER   NO-UNDO.

  DEFINE VARIABLE hPolicyBuffer AS HANDLE      NO-UNDO.

  DEFINE VARIABLE rawUUID       AS RAW         NO-UNDO.
 
  rawUUID     = GENERATE-UUID.
  cBase64UUID = BASE64-ENCODE(rawUUID).
  cGuid       = SUBSTRING(BASE64-ENCODE(GENERATE-UUID), 1, 22).

  hPolicyBuffer = ghAuditDset::ttAuditPolicy.
  hPolicyBuffer:BUFFER-CREATE().

  ASSIGN hPolicyBuffer::_audit-policy-guid         = cGuid
         hPolicyBuffer::_audit-policy-name         = pcPolicyName
         hPolicyBuffer::_audit-policy-description  = pcPolicyDesc
         hPolicyBuffer::_Audit-data-security-level = piSecurity
         hPolicyBuffer::_Audit-custom-detail-level = piCustomDetail
         hPolicyBuffer::_Audit-policy-active       = plActive.

  phList:ADD-LAST(pcPolicyName,cGuid).
  phList:SCREEN-VALUE = cGuid.
  APPLY "VALUE-CHANGED" TO phList.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE deleteFields C-Win
PROCEDURE deleteFields :
/*------------------------------------------------------------------------------
  Purpose:    
  Parameters:  <none>
  Notes:      
------------------------------------------------------------------------------*/
  DEFINE INPUT  PARAMETER pcGuid     AS CHARACTER   NO-UNDO.
  DEFINE INPUT  PARAMETER pcFileName AS CHARACTER   NO-UNDO.
 
  DEFINE VARIABLE hFieldBuffer AS HANDLE      NO-UNDO.
  DEFINE VARIABLE hFieldQuery  AS HANDLE      NO-UNDO.

  CREATE WIDGET-POOL.
  hFieldBuffer = ghAuditDset::ttAuditFieldPolicy.
 
  DO TRANSACTION:
    CREATE QUERY hFieldQuery.
    hFieldQuery:SET-BUFFERS(hFieldBuffer).
    hFieldQuery:QUERY-PREPARE("FOR EACH " + hFieldBuffer:NAME + " EXCLUSIVE-LOCK " +
                              "WHERE " + hFieldBuffer:NAME + "._audit-policy-guid EQ ~'" +
                              pcGuid + "~' AND " + hFieldBuffer:NAME + "._file-name EQ ~'" +
                              pcFileName + "~'").
    hFieldQuery:QUERY-OPEN().
    hFieldQuery:GET-FIRST().

    DO WHILE NOT hFieldQuery:QUERY-OFF-END:
      hFieldBuffer:BUFFER-DELETE().
      hFieldQuery:GET-NEXT().
    END.
  END.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI C-Win  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Hide all frames. */
  HIDE FRAME DEFAULT-FRAME.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI C-Win  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY cbDatabase cbPolicies
      WITH FRAME DEFAULT-FRAME IN WINDOW C-Win.
  ENABLE cbDatabase cbPolicies btnAddPolicy btnUpdatePolicy btnNewFilePolicy
         btnNewFieldPolicy btnSave btnDone
      WITH FRAME DEFAULT-FRAME IN WINDOW C-Win.
  {&OPEN-BROWSERS-IN-QUERY-DEFAULT-FRAME}
  VIEW C-Win.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE loadDBList C-Win
PROCEDURE loadDBList :
/*------------------------------------------------------------------------------
  Purpose:    
  Parameters:  <none>
  Notes:      
------------------------------------------------------------------------------*/
  DEFINE INPUT  PARAMETER phList AS HANDLE      NO-UNDO.

  DEFINE VARIABLE iDB        AS INTEGER     NO-UNDO.

  DEFINE VARIABLE hAudPolicy AS HANDLE      NO-UNDO.

  phList:LIST-ITEMS = "".
  DO iDB = 1 TO NUM-DBS:
    CREATE BUFFER hAudPolicy
           FOR TABLE LDBNAME(iDB) + "._aud-audit-policy" NO-ERROR.
    IF VALID-HANDLE(hAudPolicy) THEN DO:
      phList:ADD-LAST(LDBNAME(iDB)).
      DELETE OBJECT hAudPolicy.
    END.
  END.
  phList:SCREEN-VALUE = phList:ENTRY(1).
  APPLY "VALUE-CHANGED" TO phList.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE loadPolicyDetails C-Win
PROCEDURE loadPolicyDetails :
/*------------------------------------------------------------------------------
  Purpose:    
  Parameters:  <none>
  Notes:      
------------------------------------------------------------------------------*/
  DEFINE INPUT  PARAMETER pcPolicyGuid AS CHARACTER   NO-UNDO.

  DEFINE VARIABLE hFileBrowse  AS HANDLE      NO-UNDO.

  OPEN QUERY qFilePolicy
       FOR EACH ttFilePolicy
           WHERE ttFilePolicy.tcPolicyGuid EQ pcPolicyGuid.
 
  APPLY "VALUE-CHANGED" TO BROWSE bFilePolicy.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE loadPolicyList C-Win
PROCEDURE loadPolicyList :
/*------------------------------------------------------------------------------
  Purpose:    
  Parameters:  <none>
  Notes:      
------------------------------------------------------------------------------*/
  DEFINE INPUT  PARAMETER pcDatabase AS CHARACTER   NO-UNDO.
  DEFINE INPUT  PARAMETER phList     AS HANDLE      NO-UNDO.

  DEFINE VARIABLE hPolicyBuffer  AS HANDLE      NO-UNDO.
  DEFINE VARIABLE hPolicyQuery   AS HANDLE      NO-UNDO.
  DEFINE VARIABLE hFileBuffer    AS HANDLE      NO-UNDO.
  DEFINE VARIABLE hFileQuery     AS HANDLE      NO-UNDO.
  DEFINE VARIABLE hFieldBuffer   AS HANDLE      NO-UNDO.
  DEFINE VARIABLE hFieldQuery    AS HANDLE      NO-UNDO.
  DEFINE VARIABLE h_FileQuery    AS HANDLE      NO-UNDO.
  DEFINE VARIABLE h_FileBuffer   AS HANDLE      NO-UNDO.

  DEFINE VARIABLE iField         AS INTEGER     NO-UNDO.

  CREATE WIDGET-POOL.

  CREATE QUERY h_FileQuery.
  CREATE BUFFER h_FileBuffer FOR TABLE pcDatabase + "._file".

  h_FileQuery:SET-BUFFERS(h_FileBuffer).
  h_FileQuery:QUERY-PREPARE("FOR EACH _file WHERE _tbl-type EQ ~'T~' NO-LOCK").
  h_FileQuery:QUERY-OPEN().
  h_FileQuery:GET-FIRST().

  gcFileNames = " ,".
  DO WHILE NOT h_FileQuery:QUERY-OFF-END:
    gcFileNames = gcFileNames + (IF (gcFileNames GT "") EQ TRUE THEN "," ELSE "") +
                  h_FileBuffer::_file-name.
    h_FileQuery:GET-NEXT().
  END.

  phList:LIST-ITEM-PAIRS = ",".
  RUN fill-audit-dataset IN hAuditUtils
      ( INPUT  pcDatabase,
        OUTPUT DATASET-HANDLE ghAuditDset BY-REFERENCE ).

  ASSIGN hPolicyBuffer = ghAuditDset::ttAuditPolicy
         hFileBuffer   = ghAuditDset::ttAuditFilePolicy
         hFieldBuffer  = ghAuditDset::ttAuditFieldPolicy.
 
  CREATE QUERY hPolicyQuery.
  hPolicyQuery:SET-BUFFERS(hPolicyBuffer).
  hPolicyQuery:QUERY-PREPARE("FOR EACH " + hPolicyBuffer:NAME).
  hPolicyQuery:QUERY-OPEN().
  hPolicyQuery:GET-FIRST().

  DO WHILE NOT hPolicyQuery:QUERY-OFF-END:
    phList:ADD-LAST(hPolicyBuffer::_audit-policy-name,
                    hPolicyBuffer::_audit-policy-guid).
    hPolicyQuery:GET-NEXT().
  END.

  EMPTY TEMP-TABLE ttFilePolicy.
  EMPTY TEMP-TABLE ttFieldPolicy.
  CREATE QUERY hFileQuery.
  CREATE QUERY hFieldQuery.

  hFileQuery:SET-BUFFERS(hFileBuffer).
  hFileQuery:QUERY-PREPARE("FOR EACH " + hFileBuffer:NAME).
  hFileQuery:QUERY-OPEN().
  hFileQuery:GET-FIRST().

  DO WHILE NOT hFileQuery:QUERY-OFF-END:
    CREATE ttFilePolicy.
    ASSIGN ttFilePolicy.tcPolicyGuid  = hFileBuffer::_audit-policy-guid
           ttFilePolicy.tcFileName    = hFileBuffer::_file-name
           ttFilePolicy.tcCreateLevel = ENTRY(LOOKUP(STRING(hFileBuffer::_audit-create-level),"0,1,12"),
                                              "Off,Minimum,Standard")
           ttFilePolicy.tcUpdateLevel = ENTRY(LOOKUP(STRING(hFileBuffer::_audit-update-level),"0,1,12,13"),
                                              "Off,Minimum,Standard,Full")
           ttFilePolicy.tcDeleteLevel = ENTRY(LOOKUP(STRING(hFileBuffer::_audit-delete-level),"0,1,12"),
                                              "Off,Minimum,Standard").
    hFileQuery:GET-NEXT().
  END.

  hFieldQuery:SET-BUFFERS(hFieldBuffer).
  hFieldQuery:QUERY-PREPARE("FOR EACH " + hFieldBuffer:NAME).
  hFieldQuery:QUERY-OPEN().
  hFieldQuery:GET-FIRST().

  DO WHILE NOT hFieldQuery:QUERY-OFF-END:
    CREATE ttFieldPolicy.
    ASSIGN ttFieldPolicy.tcPolicyGuid  = hFieldBuffer::_audit-policy-guid
           ttFieldPolicy.tcFileName    = hFieldBuffer::_file-name
           ttFieldPolicy.tcFieldName   = hFieldBuffer::_field-name
           ttFieldPolicy.tcCreateLevel = ENTRY(LOOKUP(STRING(hFieldBuffer::_audit-create-level),"-1,0,1,12"),
                                               "Off,Use Table,Minimum,Standard")
           ttFieldPolicy.tcUpdateLevel = ENTRY(LOOKUP(STRING(hFieldBuffer::_audit-update-level),"-1,0,1,12,13"),
                                              "Off,Use Table,Minimum,Standard,Full")
           ttFieldPolicy.tcDeleteLevel = ENTRY(LOOKUP(STRING(hFieldBuffer::_audit-delete-level),"-1,0,1,12"),
                                              "Off,Use Table,Minimum,Standard").
    hFieldQuery:GET-NEXT().
  END.
 
  IF TRIM(phList:LIST-ITEM-PAIRS) NE "," AND
     (TRIM(phList:LIST-ITEM-PAIRS) GT "") EQ TRUE THEN DO:
    phList:SCREEN-VALUE = phList:ENTRY(2).
    APPLY "VALUE-CHANGED" TO phList.
  END.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE localEnable C-Win
PROCEDURE localEnable :
/*------------------------------------------------------------------------------
  Purpose:    
  Parameters:  <none>
  Notes:      
------------------------------------------------------------------------------*/
  DISPLAY cbDatabase cbPolicies bFilePolicy bFieldPolicy
      WITH FRAME {&FRAME-NAME}.
  ENABLE cbDatabase cbPolicies btnAddPolicy btnUpdatePolicy
         bFilePolicy bFieldPolicy btnNewFilePolicy btnNewFieldPolicy
         btnSave
      WITH FRAME {&FRAME-NAME}.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE reassignFields C-Win
PROCEDURE reassignFields :
/*------------------------------------------------------------------------------
  Purpose:    
  Parameters:  <none>
  Notes:      
------------------------------------------------------------------------------*/
  DEFINE INPUT  PARAMETER pcGuid        AS CHARACTER   NO-UNDO.
  DEFINE INPUT  PARAMETER pcOldFileName AS CHARACTER   NO-UNDO.
  DEFINE INPUT  PARAMETER pcNewFileName AS CHARACTER   NO-UNDO.

  DEFINE VARIABLE hFieldBuffer AS HANDLE      NO-UNDO.
  DEFINE VARIABLE hFieldQuery  AS HANDLE      NO-UNDO.

  CREATE WIDGET-POOL.
  hFieldBuffer = ghAuditDset::ttAuditFieldPolicy.
 
  DO TRANSACTION:
    CREATE QUERY hFieldQuery.
    hFieldQuery:SET-BUFFERS(hFieldBuffer).
    hFieldQuery:QUERY-PREPARE("FOR EACH " + hFieldBuffer:NAME + " EXCLUSIVE-LOCK " +
                              "WHERE " + hFieldBuffer:NAME + "._audit-policy-guid EQ ~'" +
                              pcGuid + "~' AND " + hFieldBuffer:NAME + "._file-name EQ ~'" +
                              pcOldFileName + "~'").
    hFieldQuery:QUERY-OPEN().
    hFieldQuery:GET-FIRST().

    DO WHILE NOT hFieldQuery:QUERY-OFF-END:
      hFieldBuffer::_file-name = pcNewFileName.
      hFieldQuery:GET-NEXT().
    END.
  END.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE setTrackingChanges C-Win
PROCEDURE setTrackingChanges :
/*------------------------------------------------------------------------------
  Purpose:    
  Parameters:  <none>
  Notes:      
------------------------------------------------------------------------------*/
  DEFINE INPUT  PARAMETER plTrackChanges AS LOGICAL     NO-UNDO.

  ASSIGN ghAuditDset::ttAuditPolicy:TABLE-HANDLE:TRACKING-CHANGES      = plTrackChanges
         ghAuditDset::ttAuditFilePolicy:TABLE-HANDLE:TRACKING-CHANGES  = plTrackChanges
         ghAuditDset::ttAuditFieldPolicy:TABLE-HANDLE:TRACKING-CHANGES = plTrackChanges.
        
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE updateFieldPolicy C-Win
PROCEDURE updateFieldPolicy :
/*------------------------------------------------------------------------------
  Purpose:    
  Parameters:  <none>
  Notes:      
------------------------------------------------------------------------------*/
  DEFINE INPUT  PARAMETER pcGuid             AS CHARACTER   NO-UNDO.
  DEFINE INPUT  PARAMETER pcTableName        AS CHARACTER   NO-UNDO.
  DEFINE INPUT  PARAMETER pcOldFieldName     AS CHARACTER   NO-UNDO.
  DEFINE INPUT  PARAMETER pcNewFieldName     AS CHARACTER   NO-UNDO.
  DEFINE INPUT  PARAMETER piCreateLevel      AS INTEGER     NO-UNDO.
  DEFINE INPUT  PARAMETER piUpdateLevel      AS INTEGER     NO-UNDO.
  DEFINE INPUT  PARAMETER piDeleteLevel      AS INTEGER     NO-UNDO.
  DEFINE INPUT  PARAMETER piReadLevel        AS INTEGER     NO-UNDO.
  DEFINE INPUT  PARAMETER piIdentifyingField AS INTEGER     NO-UNDO.
 
  DEFINE VARIABLE hFieldBuffer  AS HANDLE      NO-UNDO.

  DEFINE BUFFER bFieldPolicy FOR ttFieldPolicy.

  hFieldBuffer = ghAuditDset::ttAuditFieldPolicy.
  hFieldBuffer:FIND-FIRST("WHERE " + hFieldBuffer:NAME + "._audit-policy-guid EQ ~'" +
                          pcGuid + "~' AND " + hFieldBuffer:NAME +
                          "._file-name EQ ~'" + pcTableName + "~' AND " +
                          hFieldBuffer:NAME + "._field-name EQ ~'" + pcOldFieldName,
                          EXCLUSIVE-LOCK) NO-ERROR.
  IF NOT hFieldBuffer:AVAILABLE THEN
    RETURN.

  ASSIGN hFieldBuffer::_field-name              = pcNewFieldName
         hFieldBuffer::_audit-create-level      = piCreateLevel
         hFieldBuffer::_audit-update-level      = piUpdateLevel
         hFieldBuffer::_audit-delete-level      = piDeleteLevel
         hFieldBuffer::_audit-read-level        = piReadLevel
         hFieldBuffer::_audit-identifying-field = piIdentifyingField.

  FIND FIRST bFieldPolicy WHERE bFieldPolicy.tcPolicyGuid EQ pcGuid      AND
                                bFieldPolicy.tcFileName   EQ pcTableName AND
                                bFieldPolicy.tcFieldName  EQ pcOldFieldName
       EXCLUSIVE-LOCK NO-ERROR.
  ASSIGN bFieldPolicy.tcFieldName   = pcNewFieldName
         bFieldPolicy.tcCreateLevel = ENTRY(LOOKUP(STRING(piCreateLevel),"0,1,12"),
                                           "Off,Minimum,Standard")
         bFieldPolicy.tcUpdateLevel = ENTRY(LOOKUP(STRING(piUpdateLevel),"0,1,12,13"),
                                           "Off,Minimum,Standard,Full")
         bFieldPolicy.tcDeleteLevel = ENTRY(LOOKUP(STRING(piDeleteLevel),"0,1,12"),
                                           "Off,Minimum,Standard").

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE updateFilePolicy C-Win
PROCEDURE updateFilePolicy :
/*------------------------------------------------------------------------------
  Purpose:    
  Parameters:  <none>
  Notes:      
------------------------------------------------------------------------------*/
  DEFINE INPUT  PARAMETER pcGuid          AS CHARACTER   NO-UNDO.
  DEFINE INPUT  PARAMETER pcFileName      AS CHARACTER   NO-UNDO.
  DEFINE INPUT  PARAMETER pcTableName     AS CHARACTER   NO-UNDO.
  DEFINE INPUT  PARAMETER piCreateLevel   AS INTEGER     NO-UNDO.
  DEFINE INPUT  PARAMETER piCreateEventId AS INTEGER     NO-UNDO.
  DEFINE INPUT  PARAMETER piUpdateLevel   AS INTEGER     NO-UNDO.
  DEFINE INPUT  PARAMETER piUpdateEventId AS INTEGER     NO-UNDO.
  DEFINE INPUT  PARAMETER piDeleteLevel   AS INTEGER     NO-UNDO.
  DEFINE INPUT  PARAMETER piDeleteEventId AS INTEGER     NO-UNDO.
 
  DEFINE VARIABLE hFileBuffer   AS HANDLE      NO-UNDO.

  DEFINE VARIABLE lNameChanged  AS LOGICAL     NO-UNDO.

  DEFINE BUFFER bFilePolicy FOR ttFilePolicy.

  hFileBuffer = ghAuditDset::ttAuditFilePolicy.
  hFileBuffer:FIND-FIRST("WHERE " + hFileBuffer:NAME + "._audit-policy-guid EQ ~'" +
                         pcGuid + "~' AND " + hFileBuffer:NAME +
                         "._file-name EQ ~'" + pcFileName + "~'",EXCLUSIVE-LOCK) NO-ERROR.
  IF NOT hFileBuffer:AVAILABLE THEN
    RETURN.

  ASSIGN lNameChanged                     = (pcFileName NE pcTableName)
         hFileBuffer::_file-name          = pcTableName
         hFileBuffer::_audit-create-level = piCreateLevel
         hFileBuffer::_create-event-id    = piCreateEventId
         hFileBuffer::_audit-update-level = piUpdateLevel
         hFileBuffer::_update-event-id    = piUpdateEventId
         hFileBuffer::_audit-delete-level = piDeleteLevel
         hFileBuffer::_delete-event-id    = piDeleteEventId.

  IF lNameChanged THEN
    RUN reassignFields ( INPUT pcGuid,
                         INPUT pcFileName,
                         INPUT pcTableName ).

  FIND FIRST bFilePolicy WHERE bFilePolicy.tcPolicyGuid EQ pcGuid     AND
                               bFilePolicy.tcFileName   EQ pcFileName EXCLUSIVE-LOCK NO-ERROR.
  ASSIGN bFilePolicy.tcFileName = pcTableName
         bFilePolicy.tcCreateLevel = ENTRY(LOOKUP(STRING(piCreateLevel),"0,1,12"),
                                           "Off,Minimum,Standard")
         bFilePolicy.tcUpdateLevel = ENTRY(LOOKUP(STRING(piUpdateLevel),"0,1,12,13"),
                                           "Off,Minimum,Standard,Full")
         bFilePolicy.tcDeleteLevel = ENTRY(LOOKUP(STRING(piDeleteLevel),"0,1,12"),
                                           "Off,Minimum,Standard").

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE updatePolicy C-Win
PROCEDURE updatePolicy :
/*------------------------------------------------------------------------------
  Purpose:    
  Parameters:  <none>
  Notes:      
------------------------------------------------------------------------------*/
  DEFINE INPUT  PARAMETER pcGuid         AS CHARACTER   NO-UNDO.
  DEFINE INPUT  PARAMETER pcPolicyName   AS CHARACTER   NO-UNDO.
  DEFINE INPUT  PARAMETER pcPolicyDesc   AS CHARACTER   NO-UNDO.
  DEFINE INPUT  PARAMETER piSecurity     AS INTEGER     NO-UNDO.
  DEFINE INPUT  PARAMETER piCustomDetail AS INTEGER     NO-UNDO.
  DEFINE INPUT  PARAMETER plActive       AS LOGICAL     NO-UNDO.
  DEFINE INPUT  PARAMETER phList         AS HANDLE      NO-UNDO.

  DEFINE VARIABLE hPolicyBuffer AS HANDLE      NO-UNDO.

  DEFINE VARIABLE lNameChanged  AS LOGICAL     NO-UNDO.

  hPolicyBuffer = ghAuditDset::ttAuditPolicy.
  hPolicyBuffer:FIND-FIRST("WHERE " + hPolicyBuffer:NAME + "._audit-policy-guid EQ ~'" +
                           pcGuid + "~'",EXCLUSIVE-LOCK) NO-ERROR.
  IF NOT hPolicyBuffer:AVAILABLE THEN
    RETURN.

  lNameChanged = (hPolicyBuffer::_audit-policy-name NE pcPolicyName).
  hPolicyBuffer::_audit-policy-name         = pcPolicyName.
  hPolicyBuffer::_audit-policy-description  = pcPolicyDesc.
  hPolicyBuffer::_Audit-data-security-level = piSecurity.
  hPolicyBuffer::_Audit-custom-detail-level = piCustomDetail.
  hPolicyBuffer::_Audit-policy-active       = plActive.

  IF lNameChanged THEN DO:
    phList:DELETE(pcGuid).
    phList:ADD-LAST(pcPolicyName,pcGuid).
  END.

  phList:SCREEN-VALUE = pcGuid.
  APPLY "VALUE-CHANGED" TO phList.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE writeChanges C-Win
PROCEDURE writeChanges :
/*------------------------------------------------------------------------------
  Purpose:    
  Parameters:  <none>
  Notes:      
------------------------------------------------------------------------------*/
 
DEFINE VARIABLE hDSChanges    AS HANDLE      NO-UNDO.
DEFINE VARIABLE hQuery        AS HANDLE      NO-UNDO.
DEFINE VARIABLE hBuffer       AS HANDLE      NO-UNDO.
DEFINE VARIABLE hBefore       AS HANDLE      NO-UNDO.

DEFINE VARIABLE iBuffer       AS INTEGER     NO-UNDO.

DEFINE VARIABLE cStatus       AS CHARACTER   NO-UNDO INIT "".
DEFINE VARIABLE cErrorMessage AS CHARACTER   NO-UNDO.

/* turn tracking-changes off for now */
RUN setTrackingChanges ( INPUT FALSE ).

/* create a ProDataSet with the changes before sending 
   it to the other procedure */
CREATE DATASET hDSChanges.
hDSChanges:CREATE-LIKE(ghAuditDset).
hDSChanges:GET-CHANGES(ghAuditDset). /* get the changes */
cErrorMessage = "".
/* call the generic procedure passing our local ProDataSet */
RUN update-auditing-policies IN hAuditUtils 
    ( INPUT cbDatabase:SCREEN-VALUE IN FRAME {&FRAME-NAME},
      INPUT-OUTPUT DATASET-HANDLE hDSChanges BY-REFERENCE ).

cErrorMessage = RETURN-VALUE.
/* turn tracking changes back on */
RUN setTrackingChanges ( INPUT TRUE ).

/* Check the ERROR status that might have been returned. */
IF cErrorMessage EQ "" AND
  hDSChanges:ERROR THEN DO:
  /* There was an error somewhere in the updates. Find it. */
  DO iBuffer = 1 TO hDSChanges:NUM-BUFFERS.
    CREATE QUERY hQuery.
    hBuffer = hDSChanges:GET-BUFFER-HANDLE(iBuffer):BEFORE-BUFFER.
    hQuery:SET-BUFFERS(hBuffer).
    hQuery:QUERY-PREPARE("FOR EACH " + hBuffer:NAME).
    hQuery:QUERY-OPEN().
    hQuery:GET-FIRST().
     
    DO WHILE NOT hQuery:QUERY-OFF-END:
      IF hBuffer:ERROR THEN
        cStatus = cStatus + hBuffer:ERROR-STRING + CHR(10) NO-ERROR.
      hQuery:GET-NEXT().
    END.
    hQuery:QUERY-CLOSE().
    DELETE OBJECT hQuery.
  END.
END.

/* delete the ProDataSet with changes */
DELETE OBJECT hDSChanges.
IF cErrorMessage NE "":U THEN
  MESSAGE cErrorMessage VIEW-AS ALERT-BOX ERROR.
IF cStatus EQ "" THEN
    /* if no errors so far, accept all the changes */
    ghAuditDset:ACCEPT-CHANGES().
ELSE
   MESSAGE cStatus VIEW-AS ALERT-BOX ERROR.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK  _PROCEDURE C-Win-layouts _LAYOUT-CASES
PROCEDURE C-Win-layouts:
  DEFINE INPUT PARAMETER layout AS CHARACTER                     NO-UNDO.
  DEFINE VARIABLE lbl-hndl AS WIDGET-HANDLE                      NO-UNDO.
  DEFINE VARIABLE widg-pos AS DECIMAL                            NO-UNDO.

  /* Copy the name of the active layout into a variable accessible to   */
  /* the rest of this file.                                             */
  C-Win-layout = layout.

  CASE layout:
    WHEN "Master Layout" THEN DO:
      ASSIGN
         &IF '{&WINDOW-SYSTEM}' NE 'TTY':U &THEN
         C-Win:HIDDEN                                      = yes &ENDIF
         &IF '{&WINDOW-SYSTEM}' NE 'TTY' &THEN
         C-Win:HEIGHT                                      = 21 &ENDIF
         &IF '{&WINDOW-SYSTEM}' NE 'TTY':U &THEN
         C-Win:WIDTH                                       = 80 &ENDIF NO-ERROR.

      ASSIGN
         &IF '{&WINDOW-SYSTEM}' NE 'TTY':U &THEN
         FRAME DEFAULT-FRAME:HIDDEN                        = yes &ENDIF
         &IF '{&WINDOW-SYSTEM}' NE 'TTY':U &THEN
         FRAME DEFAULT-FRAME:HIDDEN                        = yes &ENDIF
         FRAME DEFAULT-FRAME:HEIGHT                        = 21
         FRAME DEFAULT-FRAME:WIDTH                         = 80 NO-ERROR.

      ASSIGN
         btnNewFieldPolicy:HIDDEN IN FRAME DEFAULT-FRAME   = yes
         btnNewFieldPolicy:COL IN FRAME DEFAULT-FRAME      = 72
         btnNewFieldPolicy:HIDDEN IN FRAME DEFAULT-FRAME   = no NO-ERROR.

      ASSIGN
         btnNewFilePolicy:HIDDEN IN FRAME DEFAULT-FRAME    = yes
         btnNewFilePolicy:COL IN FRAME DEFAULT-FRAME       = 72
         btnNewFilePolicy:HIDDEN IN FRAME DEFAULT-FRAME    = no NO-ERROR.

      ASSIGN

         FRAME DEFAULT-FRAME:VIRTUAL-WIDTH                 = 80.00
                    WHEN FRAME DEFAULT-FRAME:SCROLLABLE
         &IF '{&WINDOW-SYSTEM}' NE 'TTY':U &THEN
         FRAME DEFAULT-FRAME:HIDDEN                        = no &ENDIF NO-ERROR.

      ASSIGN

         FRAME DEFAULT-FRAME:VIRTUAL-HEIGHT                = 21.00
                    WHEN FRAME DEFAULT-FRAME:SCROLLABLE
         &IF '{&WINDOW-SYSTEM}' NE 'TTY':U &THEN
         FRAME DEFAULT-FRAME:HIDDEN                        = no &ENDIF NO-ERROR.

      ASSIGN
         &IF '{&WINDOW-SYSTEM}' NE 'TTY':U &THEN
         C-Win:HIDDEN                                      = no &ENDIF NO-ERROR.

    END.  /* Master Layout Layout Case */

    WHEN "Standard Character":U THEN DO:
      ASSIGN
         &IF '{&WINDOW-SYSTEM}' NE 'TTY':U &THEN
         FRAME DEFAULT-FRAME:HIDDEN                        = yes &ENDIF NO-ERROR.

      ASSIGN

         FRAME DEFAULT-FRAME:VIRTUAL-WIDTH                 = 80.00
                    WHEN FRAME DEFAULT-FRAME:SCROLLABLE
         &IF '{&WINDOW-SYSTEM}' NE 'TTY':U &THEN
         FRAME DEFAULT-FRAME:HIDDEN                        = no &ENDIF NO-ERROR.

    END.  /* Standard Character Layout Case */

    WHEN "winlayout":U THEN DO:
      ASSIGN
         &IF '{&WINDOW-SYSTEM}' NE 'TTY':U &THEN
         C-Win:HIDDEN                                      = yes &ENDIF
         &IF '{&WINDOW-SYSTEM}' NE 'TTY' &THEN
         C-Win:HEIGHT                                      = 21.52 &ENDIF
         &IF '{&WINDOW-SYSTEM}' NE 'TTY':U &THEN
         C-Win:WIDTH                                       = 87 &ENDIF.

      ASSIGN
         &IF '{&WINDOW-SYSTEM}' NE 'TTY':U &THEN
         FRAME DEFAULT-FRAME:HIDDEN                        = yes &ENDIF
         FRAME DEFAULT-FRAME:HEIGHT                        = 21.52
         FRAME DEFAULT-FRAME:WIDTH                         = 87.

      ASSIGN
         btnNewFieldPolicy:HIDDEN IN FRAME DEFAULT-FRAME   = yes
         btnNewFieldPolicy:COL IN FRAME DEFAULT-FRAME      = 79.4
         btnNewFieldPolicy:HIDDEN IN FRAME DEFAULT-FRAME   = no.

      ASSIGN
         btnNewFilePolicy:HIDDEN IN FRAME DEFAULT-FRAME    = yes
         btnNewFilePolicy:COL IN FRAME DEFAULT-FRAME       = 79.4
         btnNewFilePolicy:HIDDEN IN FRAME DEFAULT-FRAME    = no.

      ASSIGN

         FRAME DEFAULT-FRAME:VIRTUAL-HEIGHT                = 21.52
                    WHEN FRAME DEFAULT-FRAME:SCROLLABLE

         FRAME DEFAULT-FRAME:VIRTUAL-WIDTH                 = 87.00
                    WHEN FRAME DEFAULT-FRAME:SCROLLABLE
         &IF '{&WINDOW-SYSTEM}' NE 'TTY':U &THEN
         FRAME DEFAULT-FRAME:HIDDEN                        = no &ENDIF.

      ASSIGN
         &IF '{&WINDOW-SYSTEM}' NE 'TTY':U &THEN
         C-Win:VIRTUAL-HEIGHT                              = 21.52 &ENDIF
         &IF '{&WINDOW-SYSTEM}' NE 'TTY':U &THEN
         C-Win:VIRTUAL-WIDTH                               = 112.40 &ENDIF
         &IF '{&WINDOW-SYSTEM}' NE 'TTY':U &THEN
         C-Win:HIDDEN                                      = no &ENDIF.

    END.  /* winlayout Layout Case */

  END CASE.
END PROCEDURE.  /* C-Win-layouts */
&ANALYZE-RESUME